# All files / src/utils classes.js

54.72% Statements 29/53
33.33% Branches 10/30
100% Functions 7/7
58% Lines 29/50

Press n or j to go to the next uncovered block, b, p or k for the previous block.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163

    18x

    18x

    18x

    18x
    172x

    172x

    172x
    172x

    18x

    77x
    77x
    77x

    18x

    79x
    79x
    79x

    18x

    2x
    2x

    2x

    2x

    18x
    1x
    1x
    1x
    1x
    1x

    18x
    13x

     /**
     * Module dependencies.
     */

    var index = require('./index-of')

    /**
     * Whitespace regexp.
     */

    var re = /\s+/

    /**
     * toString reference.
     */

    var toString = Object.prototype.toString

    /**
     * Wrap `el` in a `ClassList`.
     *
     * @param {Element} el
     * @return {ClassList}
     * @api public
     */

    module.exports = function (el) {
      return new ClassList(el)
    }

    /**
     * Initialize a new ClassList for `el`.
     *
     * @param {Element} el
     * @api private
     */

    function ClassList(el) {
      Iif (!el || !el.nodeType) {
        throw new Error('A DOM element reference is required')
      }
      this.el = el
      this.list = el.classList
    }

    /**
     * Add class `name` if not already present.
     *
     * @param {String} name
     * @return {ClassList}
     * @api public
     */

    ClassList.prototype.add = function (name) {
      // classList
      Eif (this.list) {
        this.list.add(name)
        return this
      }

      // fallback
      var arr = this.array()
      var i = index(arr, name)
      if (!~i) arr.push(name)
      this.el.className = arr.join(' ')
      return this
    }

    /**
     * Remove class `name` when present, or
     * pass a regular expression to remove
     * any which match.
     *
     * @param {String|RegExp} name
     * @return {ClassList}
     * @api public
     */

    ClassList.prototype.remove = function (name) {
      // classList
      Eif (this.list) {
        this.list.remove(name)
        return this
      }

      // fallback
      var arr = this.array()
      var i = index(arr, name)
      if (~i) arr.splice(i, 1)
      this.el.className = arr.join(' ')
      return this
    }

    /**
     * Toggle class `name`, can force state via `force`.
     *
     * For browsers that support classList, but do not support `force` yet,
     * the mistake will be detected and corrected.
     *
     * @param {String} name
     * @param {Boolean} force
     * @return {ClassList}
     * @api public
     */

    ClassList.prototype.toggle = function (name, force) {
      // classList
      Eif (this.list) {
        Iif ('undefined' !== typeof force) {
          if (force !== this.list.toggle(name, force)) {
            this.list.toggle(name) // toggle again to correct
          }
        } else {
          this.list.toggle(name)
        }
        return this
      }

      // fallback
      if ('undefined' !== typeof force) {
        if (!force) {
          this.remove(name)
        } else {
          this.add(name)
        }
      } else {
        if (this.has(name)) {
          this.remove(name)
        } else {
          this.add(name)
        }
      }

      return this
    }

    /**
     * Return an array of classes.
     *
     * @return {Array}
     * @api public
     */

    ClassList.prototype.array = function () {
      var className = this.el.getAttribute('class') || ''
      var str = className.replace(/^\s+|\s+$/g, '')
      var arr = str.split(re)
      Iif ('' === arr[0]) arr.shift()
      return arr
    }

    /**
     * Check if class `name` is present.
     *
     * @param {String} name
     * @return {ClassList}
     * @api public
     */

    ClassList.prototype.has = ClassList.prototype.contains = function (name) {
      return this.list ? this.list.contains(name) : !!~index(this.array(), name)
    }